public class Fish {
  // Simulation des Fiat-Shamir-Protokolls

  static int n, s, v;

  static int fAlice (int bit, int r)
    {if (bit == 0) return r; else return (r * s) % n;}

  static int modInv (int zahl, int modul) {
    for (int i = 1; i < modul; i++)
      if ((zahl * i) % modul == 1) return i;
    return -1;
    } // Ende modInv

  static int fX (int r) {
    // Funktion von Mr. X
    int v1 = modInv(v, n);
    return (r * r * v1) % n;
    } // Ende fX

/*
  public static void main (String[] xy) {
    n = 391;
    s = 123;
    v = (s * s) % n;
    System.out.println("\n FIAT-SHAMIR-SIMULATION\n");
    for (int i = 0; i < 5; i++) {
      int r = (int) (Math.random() * n);
      int x = (r * r) % n;
      int b = (int) (Math.random() * 2);
      int y = fAlice(b, r);
      System.out.print(" (" + x + ", " + b + ", " + y + ") ");
      if (b == 0) {
        if ((r * r) % n == x)
          System.out.println(" Richtig!");
        else
          System.out.println(" Falsch!");
        } // Ende if
      else {
        if ((y * y) % n == (x * v) % n)
          System.out.println(" Richtig!");
        else
          System.out.println(" Falsch!");
        } // Ende else
      } // Ende for
    } // Ende main
*/

  public static void main (String[] xy) {
    n = 391;
    s = 123;
    v = (s * s) % n;
    System.out.println("\n FIAT-SHAMIR-SIMULATION\n");
    for (int i = 0; i < 20; i++) {
      int r = (int) (Math.random() * n);
      int x = (r * r) % n;
      int zz = (int) (Math.random() * 2);
      if (zz == 1) x = fX(r);
      int b = (int) (Math.random() * 2);
      int y = r;
      System.out.print(" (" + x + ", " + b + ", " + y + ") ");
      if (b == 0) {
        if ((r * r) % n == x)
          System.out.println("\tRichtig!");
        else
          System.out.println("\tFalsch!");
        } // Ende if
      else {
        if ((y * y) % n == (x * v) % n)
          System.out.println("\tRichtig!");
        else
          System.out.println("\tFalsch!");
        } // Ende else
      } // Ende for
    } // Ende main

  } // Ende Fish