public class Graphtest {
  // testet Klasse "Graph"

  static int n = 7; // Anzahl der Knoten
  static int[] sigma  = {4, 6, 3, 2, 5, 0, 1};

  static void GraphAufbau (Graph g) {
    g.verbinde(0, 1); g.verbinde(0, 6);
    g.verbinde(1, 5); g.verbinde(2, 3);
    g.verbinde(3, 5); g.verbinde(4, 3);
    g.verbinde(5, 6);
    } // Ende GraphAufbau

  static Graph permutiert (Graph g, int[] p) {
    // erzeugt zu g isomorphen Graph
    int n = g.AnzahlKnoten();
    Graph neu = new Graph(n, false);
    for (int i = 0; i < n - 1; i++)
      for (int j = i + 1; j < n; j++)
        if (g.istBenachbart(i, j))
          neu.verbinde(p[i], p[j]);
    return neu;
    } // Ende permutiert

  static int[] umgekehrt (int[] p) {
    // kehrt Permutation p um
    int n = p.length;
    int[] neu = new int[n];
    for (int i = 0; i < n; i++)
      for (int j = 0; j < n; j++)
        if (i == p[j]) neu[i] = j;
    return neu;
    } // Ende umgekehrt

  static int[] verkettet (int p, int q) {
    // verkettet Permutationen p mit q
    int n = q.length;
    int neu = new int[n];
    for (int i = 0; i < n; i++) neu[i] = p[q[i]];
    return neu;
    } // Ende verkettet

  public static void main (String[] xy) {
    Graph G0 = new Graph(n, false);
    GraphAufbau(G0);
    Graph G1 = permutiert(G0, sigma);
    String text = "\n" + G0.Ausgabe() + G1.Ausgabe();
    text += " Die Graphen sind ";
    if (! G0.istIsomorph(G1, sigma)) text += "nicht ";
    System.out.println(text + "isomorph");
    Graph g2 = permutiert(G1, umgekehrt(sigma));
    if (g2.istGleich(G0))
      System.out.println("\n" + g2.Ausgabe() + " gleich!");
    } // Ende main

  } // Ende Graphtest